#region Using declarations
using System;
using System.IO;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using System.Windows.Forms;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Advanced Risk Reward by Bassam Alshariti
    /// </summary>
	[Description("Advanced Risk Reward by Bassam Alshariti")]
    public class AdvancedRiskReward : Indicator
    {
        #region Variables
			
			private ToolStripButton 			btnDate1						= null;
			private ToolStripButton 			btnDate2					= null;
			private ToolStripButton 			btnDate3					= null;
			private ToolStripButton 			btnDate4					= null;
			private ToolStripButton 			btnDate5					= null;
			private ToolStrip 					strip			 			= null;
			private ToolStripSeparator  toolStripSeparator  = null;
			private ToolStripSeparator  toolStripSeparator2  = null;
			private ToolStripSeparator  toolStripSeparator3  = null;
			private ToolStripSeparator  toolStripSeparator4  = null;
			private Font	regularFont	= null;
			private List<double> HLCollection;
			private Interactive interactive  = Interactive.Yes;
			private IHorizontalLine EnterHLine,TargetHLine,StopHLine,TargetHLine2,TargetHLine3=null; 
			private IRay 			EnterRLine,TargetRLine,StopRLine,TargetRLine2,TargetRLine3=null; 
			private bool	buttonsloaded,RetrievalDone,Short,attached,InteractiveRemoved,_init = false;
			private	double	myChartMax,myChartMin,CloseFromUpperLine,CloseFromLowerLine,RangeValue,PL,RatioValuestarty,
							endy,Y,EnterLineY,TargetLineY,TargetLineY2,TargetLineY3,StopLineY,PotentialProfit,
							PotentialProfit2,PotentialProfit3,PotentialLoss,RatioValue,RatioValue2,RatioValue3=0;
			private int  	mouseY = 0; 
			private	Rectangle	myChartBounds;
			private int LinesThere = 0;
			private int mouseX,LockX,PLShiftX;
		 	private bool HLineDrawn = false; 
		    private int BaseLineBarsAgo = 0; 
			private string ratio ;
			private int ShifterX;
			private int RatioShift,InteractivePLoffset; 
			private string PLTxt;
		    private int InteractiveLineLength,CurrentOffset;
			private int counter= 0;
			private Color EntryAndCurrentPriceColor ;
			private int currentoffset,OffsetFromLastBar = 0;
			private int offset = 10; 
			private int contracts =1;
			private int userscontracts =1;
			private bool showOnStartup= true;
			private double accountSize = 10000;
			private double riskpercent = 10;
			private CalculationsBasedOn calculationsBasedOn = CalculationsBasedOn.User_Choice;
			private bool CalcBasedOnUser = true; 
			private StringFormat			stringFormat					= new StringFormat();
			private	SolidBrush				ratiotextBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				ratio2textBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				ratio3textBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				entertextBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				targettextBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				stoptextBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				UpSplitTagBrush					= new SolidBrush(Color.Empty);
			private	SolidBrush				LowerSplitTagBrush				= new SolidBrush(Color.Empty); 
			private	SolidBrush				InteractivePLBrush				= new SolidBrush(Color.Empty);
			private	SolidBrush				InteractivePriceTextBrush		= new SolidBrush(Color.Empty);
			private	SolidBrush				ArrowBrush				        = new SolidBrush(Color.Empty);
			private	System.Drawing.Font		textFont						= new Font("Arial", 10,FontStyle.Bold);
			private Color RatioTextColor;
			private Color Ratio2TextColor = Color.Transparent;
			private Color Ratio3TextColor = Color.Transparent;
			private Color TargetLinetxtColor;
			private Color StopLinetxtColor;
			private Color EnterToTargetColor;
			private Color EnterToStopColor;
			private Color UpSplitTagColor;
			private Color LowerSplitTagColor;
			private Color InteractivePLColor;
			private Color InteractivePriceColor;
			private IText StopDot,TargetDot;
			private TargetLines targetLines= TargetLines.One; 
			private Color GreenColor = Color.Green;
			private Color RedColor = Color.Red; 
			private Color PriceColor = Color.Blue; 
			private bool ContractsReadOnly = true;
			private string targets;
			private bool ray =true;
			private int RayBarsAgo; //= -10;
			private int LinesWidth; 
			private	int EnterYPixles;
			private	int TargeYPixles;
			private	int Targe2YPixles;
			private	int Targe3YPixles;
			private	int StopYPixles;
			private Color TargetBeamColor = Color.Transparent; 
			private Color EnterBeamColor = Color.Transparent;
			private Color StopBeamColor = Color.Transparent;
			private Color Target2BeamColor = Color.Transparent;
			private Color Target3BeamColor = Color.Transparent;
			private Pen TargetBeam;
			private Pen Targe2Beam;
			private Pen Targe3Beam;
			private Pen StopBeam;
			private Pen EnterBeam;
			private Color BeamColor = Color.OrangeRed;
			private int RaysX;
		
		
			
        // User defined variables (add any user defined variables below)
       #endregion

    	#region Intialize   
		protected override void Initialize()
        {
		
            Overlay				= true;
			PlotsConfigurable = false;
			PaintPriceMarkers = false;
			HLCollection = new List<double>();
			CalculateOnBarClose = false;
			ChartOnly			= true;
			//EntryAndCurrentPriceColor = (ChartControl.BackColor.GetBrightness() > 0.5 ? Color.Black:Color.LightSlateGray); // change PL text color if the background is dark
			 
					
        }
	#endregion	
		
		#region Save,Read values
		double GetValue(int index,string targets) // gets the vlaue of the array at sepcific index (first or second ...) of a specific file 
			{   
				string fileName= Bars.Instrument.MasterInstrument.Name;
				bool fileisthere=false; 	
				string filepath = Path.Combine(Environment.ExpandEnvironmentVariables("%userprofile%"),"my documents").ToString()+@"\NinjaTrader 7\bin\Custom\Ranger\"+Bars.Instrument.MasterInstrument.Name+targets+".txt";
                if (File.Exists(filepath))// if the file exists then read it 
                {
                   	if((new FileInfo(filepath).Length != 0))// if the files is not empty 
					{	
						while (System.IO.File.ReadAllLines(filepath)[0].Split(';')[index]!= null)
						{	
							return (double.Parse(System.IO.File.ReadAllLines(filepath)[0].Split(';')[index]));// -2 means Item not found
						}
					}
				}
                
				return -1 ;// return -1 if does not exists 
				
			}
			
		void WriteValue(bool Reset,string targets)// pas the file name (instrument name) and length of the final array 
			{
				
				string fileName= Bars.Instrument.MasterInstrument.Name;
				string folderpath = Path.Combine(Environment.ExpandEnvironmentVariables("%userprofile%"),@"my documents").ToString()+@"\NinjaTrader 7\bin\Custom\Ranger\";
				string filepath = Path.Combine(Environment.ExpandEnvironmentVariables("%userprofile%"),"my documents").ToString()+@"\NinjaTrader 7\bin\Custom\Ranger\"+fileName+targets+".txt";
				
    			bool IsExists = System.IO.Directory.Exists(folderpath); // if folder exists 
				
    			if(!IsExists)// if folder exists  = false then create new one 
        		System.IO.Directory.CreateDirectory(folderpath);
				
				using (System.IO.StreamWriter outfile = new System.IO.StreamWriter(filepath) ) // write the array to new file
							{
								// first number is for lines quantity, second number is for short(1) or long (0)
								if (!Reset)
								{	
									outfile.Write("{0};",HLCollection.Count);//first number : lines quantity 
									outfile.Write("{0};",(Short? 1 : 0));//second number : short or long 
									
									for (int col = 0; col < HLCollection.Count; col++)
									{
										outfile.Write("{0};",HLCollection[col]);// we write the array from memory to file, replace the index by value position in the file
										
									}
								}
								else if (Reset)
								{
									outfile.Write("{0};",0);
								}
								outfile.Close();
							}
				
			}
	#endregion	
		
		#region OnStratup
	protected override void OnStartUp()
		{	
			if ((ChartControl != null) && (!_init))
				{
					this.ClearOutputWindow();
					this.ChartControl.ChartPanel.MouseUp += new System.Windows.Forms.MouseEventHandler(MyMouseUpEvent);
					this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(MyMouseDownEvent);
					_init = true;
				}
				
			targets =( targetLines==TargetLines.One?"-One":"-Three");
				
			try
			{
				Short= (/*(GetValue(0,targets)==0 ||*/(GetValue(1,targets)==1/* || GetValue(0,targets)==-1)*/? true:false));// if lines are 0 or second number in the file is 0 or the file does not exist it is long
				
			}
			catch (Exception exp)
			{
				
			}
			switch (interactive)
			{
				case Interactive.Yes:
					CalcBasedOnUser=true;
					TargetHLine2 = TargetHLine3 = null;
					TargetRLine2 = TargetRLine3 = null;
					break;
				case Interactive.No:
					CalcBasedOnUser=false;
					break;
			}
			
					
			
		#region buttons
				ChartControl.ToolBarEnabled = true;
				System.Windows.Forms.Control[] controls = ChartControl.Controls.Find("tsrTool", false);
				
				if (controls.Length > 0)
				{
					strip 					= (ToolStrip)controls[0];
										
					btnDate1				= new ToolStripButton("btnDate1");
					toolStripSeparator      = new ToolStripSeparator();
					btnDate2				= new ToolStripButton("btnDate2");
					toolStripSeparator2     = new ToolStripSeparator();
					btnDate3				= new ToolStripButton("btnDate3");
					toolStripSeparator3     = new ToolStripSeparator();
					btnDate4				= new ToolStripButton("btnDate4");
					toolStripSeparator4     = new ToolStripSeparator();
					btnDate5				= new ToolStripButton("btnDate5");
					
					btnDate1.Font 			= regularFont;
					btnDate2.Font 			= regularFont;
					btnDate3.Font 			= regularFont;
					btnDate1.Text 			= "Reset";
					btnDate2.Text 			= "Save Changes";
					btnDate4.Text 			= "Deattached"; 
					btnDate5.Text 			= (showOnStartup? "Hide":"Show"); 
					
					
					if (Short)
					{	
						btnDate3.Text 			= "Short";
						btnDate3.ForeColor 		= Color.Crimson;
					}
					else
					{
						btnDate3.Text 			= "Long";
						btnDate3.ForeColor 		= Color.ForestGreen;
					}
					
									
					btnDate1.Click 			+= btnDate1_Click;
					btnDate2.Click 			+= btnDate2_Click;
					btnDate3.Click 			+= btnDate3_Click;
					btnDate4.Click 			+= btnDate4_Click;
					btnDate5.Click 			+= btnDate5_Click;
					
					btnDate1.ToolTipText 	= "Start Over";
					btnDate2.ToolTipText 	= "Save Changes";
					btnDate3.ToolTipText 	= "Is the trade Short? ";
					btnDate4.ToolTipText 	= "Attach enter line to price?";
					btnDate5.ToolTipText 	= "Show/Hide indicator";
					
					btnDate5.CheckOnClick =true; 
					btnDate5.Checked= showOnStartup;
					
					strip.Items.Add(btnDate1);
					strip.Items.Add(toolStripSeparator);
					strip.Items.Add(btnDate2);
					strip.Items.Add(toolStripSeparator2);
					strip.Items.Add(btnDate4);
					strip.Items.Add(toolStripSeparator3);
					strip.Items.Add(btnDate3);
					strip.Items.Add(toolStripSeparator4);
					strip.Items.Add(btnDate5);
					
					btnDate1.ForeColor= Color.Black;
					btnDate2.ForeColor= Color.Black;
					btnDate5.ForeColor=(showOnStartup? Color.Crimson:GreenColor);
					buttonsloaded 			= true;
					
					
				}
		#endregion
		}
		
		#region buttonactions
			private void btnDate1_Click(object sender, EventArgs e)
				{
					btnDate5.Checked =true;
					showOnStartup=true;
					WriteValue(true,targets);
					ChartControl.ParentForm.Activate();
					SendKeys.SendWait("{F5}");
				}
			private void btnDate2_Click(object sender, EventArgs e)// save changes 
				{
					WriteValue(false,targets);
				}
			private void btnDate4_Click(object sender, EventArgs e)// save changes 
				{
					if (btnDate4.Text == "Deattached")
					{	
						attached= true;
						btnDate4.Text = "Attached";
					}
					else
					{
						attached= false;
						btnDate4.Text = "Deattached";
					}
					ChartControl.Refresh();
					
				}	
			private void btnDate3_Click(object sender, EventArgs e)
				
				{
					if (btnDate3.Text == "Long")
					{	
						Short = true;
						btnDate3.Text = "Short";
						btnDate3.ForeColor=Color.Crimson;
					}
					else
					{
						btnDate3.Text = "Long";
						Short = false;
						btnDate3.ForeColor=Color.ForestGreen;
					}
					ChartControl.Refresh();
					WriteValue(false,targets);
				}
			private void btnDate5_Click(object sender, EventArgs e)// save changes 
				{
					if(!btnDate5.Checked)
					{
						btnDate5.Text 			= "Show";
						btnDate5.ForeColor 		= GreenColor;
						RemoveDrawObject("TargetHLine");
						RemoveDrawObject("TargetHLine2");
						RemoveDrawObject("TargetHLine3");
						RemoveDrawObject("EnterHLine");
						RemoveDrawObject("StopHLine");
						RemoveDrawObject("TargetRLine");
						RemoveDrawObject("TargetRLine2");
						RemoveDrawObject("TargetRLine3");
						RemoveDrawObject("EnterRLine");
						RemoveDrawObject("StopRLine");
						RemoveDrawObject("TargetDot");
						RemoveDrawObject("StopDot");
												
						RetrievalDone = false;
						HLineDrawn= false; 
						EnterHLine = TargetHLine = TargetHLine2 = TargetHLine3 = StopHLine = null;
						EnterRLine = TargetRLine = TargetRLine2 = TargetRLine3 = StopRLine = null;
						ChartControl.Refresh();
					}
					else
					{
						btnDate5.Text 			= "Hide";
						btnDate5.ForeColor 		= Color.Crimson;
						RetrieveSavedLines();
						ChartControl.Refresh();						
					}
					
				}
				
			protected override void OnTermination()
				{
					if(buttonsloaded == true)
					{
						strip.Items.Remove(btnDate1);
						strip.Items.Remove(btnDate2);
						strip.Items.Remove( toolStripSeparator );
						strip.Items.Remove( toolStripSeparator2 );
						strip.Items.Remove( toolStripSeparator3 );
						strip.Items.Remove( toolStripSeparator4 );
						strip.Items.Remove( btnDate3 );
						strip.Items.Remove( btnDate4 );
						strip.Items.Remove( btnDate5 );
					}
					
					
					ratiotextBrush.Dispose();
					ratio2textBrush.Dispose();
					ratio3textBrush.Dispose();
					entertextBrush.Dispose();
					targettextBrush.Dispose();
					stoptextBrush.Dispose();
					UpSplitTagBrush.Dispose();
					LowerSplitTagBrush.Dispose();
					InteractivePLBrush.Dispose();
					InteractivePriceTextBrush.Dispose();
					ArrowBrush.Dispose();
					
					stringFormat.Dispose();
					textFont.Dispose();
								
				}
		#endregion
				
	#endregion	
		
		#region Format Price maker
		public override string FormatPriceMarker(double price)
		{
			if(Instrument.MasterInstrument.PointValue > 2000 && Instrument.MasterInstrument.PointValue <300000)
			{	
				return price.ToString("N4");
			}
			else if(Instrument.MasterInstrument.PointValue > 300000)
			{
				return price.ToString("N6");
			}
			else 
			{
				return price.ToString("N2");
			}
		}
		#endregion
	
		#region Plot				
		public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
		{
			
			/* This will ensure that our other plots are still being drawn correctly. */
			base.Plot(graphics, bounds, min, max);
			
			/* Here we grab the information we need and place it into our variables. */
			
			myChartMin = min;
			myChartMax = max;
			myChartBounds = bounds;
										
			if( btnDate5.Checked)
			{	
					
					if(!RetrievalDone)
					{
						RetrieveSavedLines();
						
					}
					int BarsOnChart =  (int)((double)(bounds.Width)/(double)ChartControl.BarSpace) ; // possible bars on chart 		
					RayBarsAgo = -1 * (int)((double)BarsOnChart/15);				 
					HandelLines();
					HandleInteractiveLines();
					EnterYPixles = ChartControl.GetYByValue(this,EnterLineY);
					TargeYPixles = ChartControl.GetYByValue(this,TargetLineY);
					Targe2YPixles = ChartControl.GetYByValue(this,TargetLineY2);
					Targe3YPixles = ChartControl.GetYByValue(this,TargetLineY3);
					
					StopYPixles = ChartControl.GetYByValue(this,StopLineY);
					int LastBarX = ChartControl.GetXByBarIdx(BarsArray[0], Count);
					int CloseY=  ChartControl.GetYByValue(BarsArray[0], Close[0]);
					
					int	upSplitTagY = ChartControl.GetYByValue(this,EnterLineY+(TargetLineY-EnterLineY)/2);
					int upSplitTagY2 = ChartControl.GetYByValue(this,TargetLineY2 - (TargetLineY2 - TargetLineY)/2);
					int upSplitTagY3 = ChartControl.GetYByValue(this,TargetLineY3 - (TargetLineY3 - TargetLineY2)/2);
					int	LowerSplitTagY = ChartControl.GetYByValue(this,EnterLineY-(EnterLineY-StopLineY)/2);	
						
					int pixelsShift =(targetLines == TargetLines.One? 250:350); // change the distance from last bar 
					int PLShift = (targetLines == TargetLines.One? (int)(pixelsShift/3.5): (int)(pixelsShift/5.5)); 
					int XCooficient = bounds.X +LastBarX+pixelsShift ; 
					int VerticalLineShift= 40;
					int BetweenLines = 75;// distance between first and second vertical lines
					RaysX = ChartControl.GetXByBarIdx(BarsArray[0], Count+Math.Abs(RayBarsAgo));// Ray line start on the plot 
					
					stringFormat.Alignment = StringAlignment.Near;
					
					// enter line text shift up or down 
					int up= -22;
					int down = 0; 
					int up23= -22;
					int down23= 0; 
					
					
					if(Math.Abs(Targe3YPixles- Targe2YPixles) < 20)
					{
						up23 =0 ;
						down23= -22; 
						
					}
					else if (Math.Abs(TargeYPixles- Targe2YPixles) < 20)
						
					{
						up = 0;
						down= -22 ; 
					}
						
					#region Ratio text
					string RatioText = "®1-"+(RatioValue).ToString("N1"); 
					ratiotextBrush.Color = RatioTextColor;							// set text color
					ratio2textBrush.Color = Ratio2TextColor;							// set text color
					ratio3textBrush.Color = Ratio3TextColor;
					graphics.DrawString(RatioText, textFont, ratiotextBrush, (targetLines == TargetLines.One? XCooficient - (VerticalLineShift - BetweenLines -52):XCooficient +45), bounds.Y + ((!(Short && targetLines == TargetLines.Three))? (targetLines == TargetLines.One?EnterYPixles:TargeYPixles+up):TargeYPixles+down), stringFormat);
					if(targetLines == TargetLines.Three)
					{	
						string Ratio2Text = "®1-"+(RatioValue2).ToString("N1");
						string Ratio3Text = "®1-"+(RatioValue3).ToString("N1");
						graphics.DrawString(Ratio2Text, textFont, ratio2textBrush, XCooficient - BetweenLines+45, bounds.Y + ((!(Short && targetLines == TargetLines.Three))? Targe2YPixles+up23:Targe2YPixles+down23), stringFormat);
						graphics.DrawString(Ratio3Text, textFont, ratio3textBrush, XCooficient - 2*BetweenLines +45, bounds.Y + ((!(Short && targetLines == TargetLines.Three))? Targe3YPixles -20:Targe3YPixles), stringFormat);
					}	
					#endregion 
					
					#region EnterLine Text
					entertextBrush.Color= PriceColor;							// set text color
					string EnterLineText =(interactive==Interactive.Yes ?"":contracts.ToString("N0")+" Cont."+" @")+FormatPriceMarker(EnterLineY)+"";
					graphics.DrawString(EnterLineText, textFont, entertextBrush, XCooficient - (VerticalLineShift - BetweenLines -52), bounds.Y + ( Short || targetLines != TargetLines.Three? EnterYPixles -22 :EnterYPixles), stringFormat);
					#endregion 
									
					#region TargetLine text
					targettextBrush.Color=TargetLinetxtColor; // set text color
					string TargetLinetxt =FormatPriceMarker(TargetLineY)+"";
					graphics.DrawString(TargetLinetxt, textFont, targettextBrush, XCooficient - (VerticalLineShift - BetweenLines+45), bounds.Y + ((!(Short && targetLines == TargetLines.Three))? TargeYPixles+up :TargeYPixles+down), stringFormat); // -22 Up 0 Down
					#endregion 
					
					#region Target Beam
					TargetBeam = new Pen(TargetBeamColor);
					TargetBeam.Width=1;
					graphics.DrawLine(TargetBeam,bounds.X, TargeYPixles, bounds.X+ bounds.Width, TargeYPixles);// from enter to upsplittag
				
					#endregion
					
					#region EnterBeam
					EnterBeam = new Pen(EnterBeamColor);
					EnterBeam.Width=1;
					graphics.DrawLine(EnterBeam,bounds.X, EnterYPixles, bounds.X+ bounds.Width, EnterYPixles);// from enter to upsplittag
					
					#endregion
					
					#region StopBeam
					StopBeam = new Pen(StopBeamColor);
					EnterBeam.Width=1;
					graphics.DrawLine(StopBeam,bounds.X, StopYPixles, bounds.X+ bounds.Width, StopYPixles);// from enter to upsplittag
					#endregion
					
					if(targetLines == TargetLines.Three)
					{
						#region Target2 Beam
						Targe2Beam = new Pen(Target2BeamColor);
						Targe2Beam.Width=1;
						graphics.DrawLine(Targe2Beam,bounds.X, Targe2YPixles, bounds.X+ bounds.Width, Targe2YPixles);// from enter to upsplittag
						#endregion
						
						#region Target3 Beam
						Targe3Beam = new Pen(Target3BeamColor);
						Targe3Beam.Width=1;
						graphics.DrawLine(Targe3Beam,bounds.X, Targe3YPixles, bounds.X+ bounds.Width, Targe3YPixles);// from enter to upsplittag
						#endregion
						
						#region Target2Line text
						
						targettextBrush.Color=TargetLinetxtColor; // set text color
						string Target2Linetxt =FormatPriceMarker(TargetLineY2)+"";
						graphics.DrawString(Target2Linetxt, textFont, targettextBrush, XCooficient - (VerticalLineShift + 45), bounds.Y + ((!(Short && targetLines == TargetLines.Three))? Targe2YPixles+up23:Targe2YPixles+down23), stringFormat);
										
						#endregion
						
						#region Target3Line text
						
						targettextBrush.Color=TargetLinetxtColor; // set text color
						string Target3Linetxt =FormatPriceMarker(TargetLineY3)+"";
						graphics.DrawString(Target3Linetxt, textFont, targettextBrush, XCooficient - (VerticalLineShift + BetweenLines + 45), bounds.Y + ((!(Short && targetLines == TargetLines.Three))? Targe3YPixles -20:Targe3YPixles), stringFormat);
					
						#endregion
					}	
					
					#region StopLine text
					stoptextBrush.Color= StopLinetxtColor;							// set text color
					string StopLinetxt =FormatPriceMarker(StopLineY)+"";
					graphics.DrawString(StopLinetxt, textFont, stoptextBrush, XCooficient - (VerticalLineShift - BetweenLines+45), bounds.Y + ((!(Short && targetLines == TargetLines.Three))? StopYPixles :StopYPixles - 22), stringFormat);
					#endregion 		
			
					#region Enter To Target & Target2 & Target3 Lines
					Pen EnterToTargetPen = new Pen(EnterToTargetColor);
					EnterToTargetPen.Width=LinesWidth;
					EnterToTargetPen.DashStyle = DashStyle.DashDot;
					
					if (!(Short && targetLines == TargetLines.Three) )
					{
						graphics.DrawLine(EnterToTargetPen, XCooficient - VerticalLineShift, EnterYPixles, XCooficient - VerticalLineShift, bounds.Y + upSplitTagY +5);// from enter to upsplittag
						
						if((bounds.Y + upSplitTagY -20)-(TargeYPixles-4)>4) // dont draw the line when enter and target are too close 
						{
							graphics.DrawLine(EnterToTargetPen, XCooficient - VerticalLineShift, bounds.Y + upSplitTagY -20, XCooficient - VerticalLineShift, bounds.Y + TargeYPixles-4);// from upsplittag to target
						}
						if(targetLines == TargetLines.Three)
						{	
							graphics.DrawLine(EnterToTargetPen, XCooficient - (VerticalLineShift+BetweenLines), EnterYPixles, XCooficient - (VerticalLineShift+BetweenLines), bounds.Y +upSplitTagY2 +5);// traget to Splittag2
												
							if((bounds.Y + upSplitTagY2 -20)-(Targe2YPixles-4)>4)
							{
								graphics.DrawLine(EnterToTargetPen, XCooficient - (VerticalLineShift+BetweenLines), upSplitTagY2 -15	, XCooficient - (VerticalLineShift+BetweenLines), bounds.Y + Targe2YPixles-4);//SplitTage2 to target2
							}
							graphics.DrawLine(EnterToTargetPen, XCooficient - (VerticalLineShift+2*BetweenLines), EnterYPixles, XCooficient - (VerticalLineShift+2*BetweenLines), bounds.Y + upSplitTagY3 +5);// traget2 to target3
							
							if((bounds.Y + upSplitTagY3 -20)-(Targe3YPixles-4)>4) // dont draw the line when enter and target are too close 
							{
								graphics.DrawLine(EnterToTargetPen, XCooficient - (VerticalLineShift+2*BetweenLines), upSplitTagY3 -15 , XCooficient -(VerticalLineShift+2*BetweenLines), bounds.Y + Targe3YPixles -4);// traget2 to target3
							}
						}
					}
					else 
					{
						EnterToTargetPen.Color = EnterToStopColor;
						graphics.DrawLine(EnterToTargetPen, XCooficient - VerticalLineShift, EnterYPixles, XCooficient - VerticalLineShift, bounds.Y + LowerSplitTagY +5);// from enter to upsplittag
						if((bounds.Y + LowerSplitTagY -20)-(StopYPixles-4)>4) // dont draw the line when enter and target are too close 
						{
							graphics.DrawLine(EnterToTargetPen, XCooficient - VerticalLineShift, bounds.Y + LowerSplitTagY -20, XCooficient - VerticalLineShift, bounds.Y + StopYPixles -4);// from upsplittag to target
						}
						
					}
					EnterToTargetPen.Dispose();
					#endregion
																					
					#region Enter To Stop Lines & Target2 & Target3 Lines
					Pen EnterToStopPen = new Pen(EnterToStopColor);
					EnterToStopPen.Width = LinesWidth;
					EnterToStopPen.DashStyle = DashStyle.DashDot;
					
					if (!(Short && targetLines == TargetLines.Three)) // if long and one target 
					{	
						graphics.DrawLine(EnterToStopPen, XCooficient - VerticalLineShift, EnterYPixles, XCooficient - VerticalLineShift, bounds.Y + LowerSplitTagY-17);// from Enter to Lowertag 
						if(((StopYPixles -5)-(bounds.Y +LowerSplitTagY+8)) > -5)
						{
							graphics.DrawLine(EnterToStopPen, XCooficient - VerticalLineShift, bounds.Y + LowerSplitTagY+8, XCooficient - VerticalLineShift, bounds.Y + StopYPixles -5);// from Lowertag to stop
						}
						
					}
					else // if short and multiple targets 
					{
						EnterToStopPen.Color =EnterToTargetColor ;
						graphics.DrawLine(EnterToStopPen, XCooficient - VerticalLineShift, EnterYPixles, XCooficient - VerticalLineShift, bounds.Y + upSplitTagY-17);// from Enter to Lowertag 
						if(((TargeYPixles -5)-(bounds.Y + upSplitTagY+12)) > -5)
						{
							graphics.DrawLine(EnterToStopPen, XCooficient - VerticalLineShift, bounds.Y + upSplitTagY +8, XCooficient - VerticalLineShift, bounds.Y + TargeYPixles-5);// from Lowertag to stop
						}
						
						graphics.DrawLine(EnterToStopPen, XCooficient - (VerticalLineShift+BetweenLines), EnterYPixles, XCooficient - (VerticalLineShift+BetweenLines), bounds.Y + upSplitTagY2-17);// from Enter to Lowertag 
						
						if(((upSplitTagY2 -5 )-(bounds.Y +Targe2YPixles-13)) < -7)
						{
							graphics.DrawLine(EnterToStopPen, XCooficient - (VerticalLineShift+BetweenLines), upSplitTagY2 +12, XCooficient - (VerticalLineShift+BetweenLines), bounds.Y + Targe2YPixles-4);// from Enter to Lowertag 
						}
						graphics.DrawLine(EnterToStopPen, XCooficient - (VerticalLineShift+2*BetweenLines), EnterYPixles, XCooficient - (VerticalLineShift+2*BetweenLines), bounds.Y +upSplitTagY3-17);// traget2 to target3
						if(((Targe3YPixles  -5)-(bounds.Y +upSplitTagY3 +12)) > -5)
						{
							graphics.DrawLine(EnterToStopPen, XCooficient - (VerticalLineShift+2*BetweenLines), upSplitTagY3 +12, XCooficient - (VerticalLineShift+2*BetweenLines), bounds.Y + Targe3YPixles -4);// traget2 to target3
					
						}
					}
						
					EnterToStopPen.Dispose();
					#endregion
					
					#region UpSplitTag text & UpSplitTag2 text & UpSplitTag3 text
					UpSplitTagBrush.Color= UpSplitTagColor;							// set text color
					string UpSplitTagTxt ="( "+(PotentialProfit*((CalcBasedOnUser)? userscontracts:1)).ToString("N0")+" )";
					graphics.DrawString(UpSplitTagTxt, textFont, UpSplitTagBrush, XCooficient - (VerticalLineShift+25), bounds.Y + upSplitTagY -14, stringFormat);
					
					/// UpSplitTag2 & UpSplitTag3  text
					if( targetLines == TargetLines.Three)
					{
						/// UpSplitTag2 text
						string UpSplitTagTxt2 ="( "+((PotentialProfit+PotentialProfit2)*((CalcBasedOnUser)? userscontracts:1)).ToString("N0")+" )";
						graphics.DrawString(UpSplitTagTxt2, textFont, UpSplitTagBrush, XCooficient - (VerticalLineShift+BetweenLines+25), bounds.Y + upSplitTagY2 -14, stringFormat);
						
						
						/// UpSplitTag3 text
						string LowerSplitTagTxt3 ="( "+((PotentialProfit+PotentialProfit2+PotentialProfit3)*((CalcBasedOnUser)? userscontracts:1)).ToString("N0")+" )";;
						graphics.DrawString(LowerSplitTagTxt3, textFont, UpSplitTagBrush, XCooficient - (VerticalLineShift+2*BetweenLines+25), bounds.Y + upSplitTagY3 -14, stringFormat);
					}	
					
					#endregion
					
					#region LowerSplitTag text
					LowerSplitTagBrush.Color= LowerSplitTagColor;							// set text color
					string LowerSplitTagTxt ="( "+(PotentialLoss*((CalcBasedOnUser)? userscontracts:1)).ToString("N0")+" )";;
					graphics.DrawString(LowerSplitTagTxt, textFont, LowerSplitTagBrush, XCooficient -(VerticalLineShift+25), bounds.Y + LowerSplitTagY -14, stringFormat);
					#endregion
					
					{	
						#region Arrowup 
							
							Pen Arrow = new Pen(Color.Black);
							ArrowBrush.Color= Color.Lime;
							int size = 4;
							int arrowshift =1;
							if(Short && targetLines == TargetLines.Three)
							{
								size = size *-1;
								arrowshift= 0;
							}	
							if(targetLines == TargetLines.Three)
							{	
								//Arrowup Traget3
								int x= XCooficient - (VerticalLineShift+2*BetweenLines); 
								int y =  Targe3YPixles + arrowshift; 
								if(Math.Abs((bounds.Y + upSplitTagY3)-(Targe3YPixles))>15) // dont draw the line when enter and target are too close 
								{
									graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x+1,y+1),new Point(x-(size),y+size),new Point(x+(size),y+size) },FillMode.Alternate); 
									graphics.DrawPolygon(Arrow, new PointF[] {new Point(x,y),new Point(x-(size),y+size),new Point(x+(size),y+size) }); 
								}
								//Arrowup Target 2 
								int x2= XCooficient - (VerticalLineShift+BetweenLines); 
								int y2 = Targe2YPixles +arrowshift;
								if(Math.Abs((bounds.Y + upSplitTagY2)-(Targe2YPixles))>15)
								{
									graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x2+1,y2+1),new Point(x2-(size),y2+size),new Point(x2+(size),y2+size) },FillMode.Alternate); 
									graphics.DrawPolygon(Arrow, new PointF[] {new Point(x2,y2),new Point(x2-(size),y2+size),new Point(x2+(size),y2+size) }); 
								}
							}
							//Arrowup Target
							ArrowBrush.Color= ((Short && targetLines == TargetLines.One)? RedColor:Color.Lime);
							int x3= XCooficient - (VerticalLineShift); 
							int y3 = TargeYPixles +arrowshift;
							if(Math.Abs((bounds.Y + upSplitTagY)-(TargeYPixles))>15 )
							{
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x3+1,y3+1),new Point(x3-(size),y3+size),new Point(x3+(size),y3+size) },FillMode.Alternate); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x3,y3),new Point(x3-(size),y3+size),new Point(x3+(size),y3+size) }); 
								
							}
							//Arrowup Stop
							ArrowBrush.Color= ((Short && targetLines == TargetLines.One)? Color.Lime:RedColor);
							int x8= XCooficient - (VerticalLineShift); 
							int y8 = EnterYPixles +arrowshift;
							if((Math.Abs((bounds.Y + StopYPixles)-(EnterYPixles))>30) && (Math.Abs((EnterYPixles)-(bounds.Y + upSplitTagY))>20) )
							{
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x8+1,y8+1),new Point(x8-(size),y8+size),new Point(x8+(size),y8+size) },FillMode.Alternate); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x8,y8),new Point(x8-(size),y8+size),new Point(x8+(size),y8+size) }); 
								
							}
							
					#endregion
						
						#region Arrowdown
							//ArrowDown Traget3 
							ArrowBrush.Color= Color.Lime;//TargetLinetxtColor;
							if(targetLines == TargetLines.Three)
							{
								int x4= XCooficient - (VerticalLineShift+2*BetweenLines); 
								int y4 =  EnterYPixles -arrowshift; 
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x4+1,y4+1),new Point(x4+(size),y4-size),new Point(x4-(size),y4-size)},FillMode.Winding); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x4,y4),new Point(x4-(size),y4-size),new Point(x4+(size),y4-size) }); 
								
								//ArrowDown Target2
								ArrowBrush.Color= Color.Lime;//TargetLinetxtColor;
								int x5= XCooficient - (VerticalLineShift+BetweenLines);
								int y5 =  EnterYPixles - arrowshift;  
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x5+1,y5+1),new Point(x5+(size),y5-size),new Point(x5-(size),y5-size)},FillMode.Winding); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x5,y5),new Point(x5-(size),y5-size),new Point(x5+(size),y5-size) }); 
							}
							//ArrowDown Target
							ArrowBrush.Color= ((Short && targetLines == TargetLines.One)? RedColor:Color.Lime);//TargetLinetxtColor;
							int x6= XCooficient - (VerticalLineShift);
							int y6 =  EnterYPixles -arrowshift;  
							if(Math.Abs((EnterYPixles)-(bounds.Y + upSplitTagY))>15 && (Math.Abs((EnterYPixles)-(bounds.Y + StopYPixles))>30))
							{
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x6+1,y6+1),new Point(x6+(size),y6-size),new Point(x6-(size),y6-size)},FillMode.Winding); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x6,y6),new Point(x6-(size),y6-size),new Point(x6+(size),y6-size) }); 
							}
							//ArrowDown Stop
							ArrowBrush.Color= ((Short && targetLines == TargetLines.One)? Color.Lime:RedColor);//TargetLinetxtColor;
							int x7= XCooficient - (VerticalLineShift);
							int y7 =  StopYPixles -arrowshift;  
							if(Math.Abs((EnterYPixles)-(bounds.Y + StopYPixles))>30)
							{
								graphics.FillPolygon(ArrowBrush,new PointF[] {new Point(x7+1,y7+1),new Point(x7+(size),y7-size),new Point(x7-(size),y7-size)},FillMode.Winding); 
								graphics.DrawPolygon(Arrow, new PointF[] {new Point(x7,y7),new Point(x7-(size),y7-size),new Point(x7+(size),y7-size) }); 
							}
							Arrow.Dispose();
					#endregion
					}
					
					if(!attached && HLineDrawn && interactive == Interactive.Yes)
					{
						
						#region Interactive PL text
					InteractivePLBrush.Color= InteractivePLColor;							// set text color
					string InteractivePLTxt =(PL*Instrument.MasterInstrument.PointValue *((CalcBasedOnUser)? userscontracts:1)).ToString("N0")+"";
					graphics.DrawString(InteractivePLTxt, textFont, InteractivePLBrush, bounds.X +LastBarX+PLShift,  CloseY - 9 , stringFormat);
					#endregion
					
						#region InteractivePrice Line
					Pen PricePen = new Pen(InteractivePLColor);
					PricePen.DashStyle = DashStyle.Solid;
					PricePen.Width= 1.5F;	
					graphics.DrawLine(PricePen, bounds.X +LastBarX , CloseY, bounds.X +LastBarX +PLShift, CloseY);// from enter to upsplittag	
					PricePen.Dispose();
					#endregion 		
												
						#region PL Boundaries Rectangle
					Pen PLBoundariesPen = new Pen(InteractivePLColor);
					PLBoundariesPen.Width=1.5F;
					SizeF textSize = graphics.MeasureString(InteractivePLTxt, textFont);
					int newW = (int) textSize.Width -3 ;
					int newH = (int) textSize.Height -1;
					graphics.DrawRectangle(PLBoundariesPen, bounds.X +LastBarX +PLShift, CloseY - 10 , newW, newH);
					PLBoundariesPen.Dispose();
					#endregion 
										
						#region InteractivePrice Text
					
					InteractivePriceTextBrush.Color= InteractivePriceColor;							// set text color
					string InteractivePriceText =FormatPriceMarker(Close[0])+"";
					graphics.DrawString(InteractivePriceText, textFont, InteractivePriceTextBrush, bounds.X +LastBarX  +(int)(((double)PLShift-20)/2)-20, bounds.Y + CloseY -20, stringFormat);
					
					#endregion
								
					}
			}
				
		}
		#endregion
		
		#region Mouse
		public void MyMouseUpEvent(object sender, MouseEventArgs e)
		{
			mouseY = e.Y;
			mouseX=e.X;
			TriggerCustomEvent(new CustomEvent(MyCustomHandler),e);
		}
		public void MyMouseDownEvent(object sender, MouseEventArgs e)
		{
			mouseY = e.Y;
			mouseX=e.X;
			if(ray)TriggerCustomEvent(new CustomEvent(MyCustomHandlerDown),e);
		}
		
			
		private void MyCustomHandler(object state) // mouse up 
		{ 
							
			if (!HLineDrawn && (GetValue(0,targets)==0  || GetValue(0,targets)==-1) )
			{	
				CreateLines(GetPriceFromY(mouseY),false);
				HandleInteractiveLines();
			}
			
			TargetBeamColor = Color.Transparent;
			Target2BeamColor = Color.Transparent;
			Target3BeamColor = Color.Transparent;
			EnterBeamColor = Color.Transparent;
			StopBeamColor = Color.Transparent;
			if(EnterBeam !=null)EnterBeam.Dispose();
			if(StopBeam !=null)StopBeam.Dispose();
			if(Targe3Beam !=null)Targe3Beam.Dispose();
			if(Targe2Beam !=null)Targe2Beam.Dispose();
			if(TargetBeam !=null)TargetBeam.Dispose();
			
		}
		private void MyCustomHandlerDown(object state) // mouse Down 
		{ 
			
			if(Math.Abs(mouseY-TargeYPixles) < 10 && mouseX >= (RaysX-10))
			{
				TargetBeamColor = BeamColor;
				
			}
			if(Math.Abs(mouseY-Targe2YPixles) < 10 && mouseX >= (RaysX-10))
			{
				Target2BeamColor = BeamColor;
				
			}
			if(Math.Abs(mouseY-Targe3YPixles) < 10 && mouseX >= (RaysX-10))
			{
				Target3BeamColor = BeamColor;
				
			}
			if(Math.Abs(mouseY-EnterYPixles) < 10 && mouseX >= (RaysX-10))
			{
				EnterBeamColor = BeamColor;
				
			}
			if(Math.Abs(mouseY-StopYPixles) < 10 && mouseX >= (RaysX-10))
			{
				StopBeamColor = BeamColor;
				
			}
			
			
		}
		
		private double GetPriceFromY(int y)
		{
			return (((((myChartBounds.Y + myChartBounds.Height) - y) * ChartControl.MaxMinusMin(myChartMax, myChartMin)) / ((double)myChartBounds.Height)) + myChartMin);
		}
		#endregion
		
		#region Creat,Collect,Handle Lines
		private void CreateLines(double LinesY,bool retrievemode)
		{
			bool noLineCreated;
			bool enterLineCreated;
			bool targetEnterCreated;
			bool targStoEntCreated;
			bool targetstopentercreated; 
			bool target2created; 
			//HiddenTarget = EnterHLine = DrawHorizontalLine("HiddenTarget",LinesY,Color.Transparent);
			//HiddenTarget.Locked =false;
			
			
			if(ray)
			{
				noLineCreated = ((EnterRLine == null && TargetRLine == null && StopRLine == null && TargetRLine2 == null && TargetRLine3 == null ));
				enterLineCreated = ((EnterRLine !=null && TargetRLine == null && StopRLine == null && TargetRLine2 == null && TargetRLine3 == null));
				targetEnterCreated = ((EnterRLine !=null && TargetRLine != null && StopRLine == null && TargetRLine2 == null && TargetRLine3 == null));
				targStoEntCreated = (targetEnterCreated && StopRLine !=null) ; 
				targetstopentercreated = (TargetRLine2 == null && TargetRLine3 == null);
				target2created =(TargetRLine2 != null && TargetRLine3 == null);
			}
			else
			{
				noLineCreated = (EnterHLine == null && TargetHLine == null && StopHLine == null && TargetHLine2 == null && TargetHLine3 == null );
				enterLineCreated = (EnterHLine !=null && TargetHLine == null && StopHLine == null && TargetHLine2 == null && TargetHLine3 == null);
				targetEnterCreated = (EnterHLine) !=null && TargetHLine != null && StopHLine == null && TargetHLine2 == null && TargetHLine3 == null;
				targStoEntCreated = (targetEnterCreated && StopHLine !=null) ; 
				
				targetstopentercreated = (TargetHLine2 == null && TargetHLine3 == null);
				target2created =(TargetHLine2 != null && TargetHLine3 == null);
			}
			if( noLineCreated )// creat enter 
			{	
				if(ray)
				{	
					EnterRLine = DrawRay("EnterRLine",RayBarsAgo,LinesY,RayBarsAgo-1,LinesY,PriceColor);
					EnterRLine.Pen.Width = LinesWidth;
					EnterRLine.Locked=false;
				}
				else
				{
					EnterHLine = DrawHorizontalLine("EnterHLine",LinesY,PriceColor);
					EnterHLine.Pen.Width = LinesWidth;
					EnterHLine.Locked=false;
				}
				StopDot = DrawText("StopDot",true,"EnterDot",0,LinesY,-10,Color.Transparent,new Font("Arial",1),StringAlignment.Far,Color.Transparent,Color.Transparent,0); // dots so that the horizontal lines still be visible when changing from daily to mins etc...
				
			}	
			else if(enterLineCreated)//great target 
			{
				if(ray)
				{
					TargetRLine = DrawRay("TargetRLine",RayBarsAgo,LinesY,RayBarsAgo-1,LinesY,PriceColor);
					TargetRLine.Pen.Width = LinesWidth;	
					TargetRLine.Locked=false;
				}
				else
				{
					TargetHLine = DrawHorizontalLine("TargetHLine",LinesY, PriceColor);
					TargetHLine.Pen.Width = LinesWidth;	
					TargetHLine.Locked=false;
				}
			
				
			}
			else if(targetEnterCreated) // create stop 
			{	
				if(ray)
				{
					StopRLine = DrawRay("StopRLine",RayBarsAgo,LinesY,RayBarsAgo-1,LinesY,PriceColor);
					StopRLine.Pen.Width = LinesWidth; 
					StopRLine.Locked=false;
				}
				else
				{
					StopHLine = DrawHorizontalLine("StopHLine",LinesY, PriceColor);
					StopHLine.Pen.Width = LinesWidth; 
					StopHLine.Locked=false;	
				}
				
				
				if(targetLines == TargetLines.One)
				{
					TargetDot = DrawText("TargetDot",true,"TargetDot",0,LinesY,+10,Color.Transparent,new Font("Arial",1),StringAlignment.Far,Color.Transparent,Color.Transparent,0); // dots so that the horizontal lines still be visible when changing from daily to mins etc...
					HLineDrawn = true;
					
					if(!retrievemode)//save without rewriting the values
					{	
						CollectLines();
						HandelLines();
						WriteValue(false,targets); 
					} 
				}
			}
			else if(targetstopentercreated)
			{
				if(ray)
				{
					TargetRLine2 = DrawRay("TargetRLine2",RayBarsAgo,LinesY,RayBarsAgo-1,LinesY,PriceColor);
					TargetRLine2.Pen.Width = LinesWidth;	
					TargetRLine2.Locked=false;
				}
				else
				{
					TargetHLine2 = DrawHorizontalLine("TargetHLine2",LinesY, PriceColor);
					TargetHLine2.Pen.Width = LinesWidth;	
					TargetHLine2.Locked=false;	
				}
				
			}
			else if(target2created)
			{
				if(ray)
				{
					TargetRLine3 = DrawRay("TargetRLine3",RayBarsAgo,LinesY,RayBarsAgo-1,LinesY,PriceColor);
					TargetRLine3.Pen.Width = LinesWidth;	
					TargetRLine3.Locked=false;
				
				}
				else
				{
					TargetHLine3 = DrawHorizontalLine("TargetHLine3",LinesY, PriceColor);
					TargetHLine3.Pen.Width = LinesWidth;	
					TargetHLine3.Locked=false;
				}
				
				TargetDot = DrawText("TargetDot",true,"TargetDot3",0,TargetLineY3,-10,Color.Transparent,new Font("Arial",1),StringAlignment.Far,Color.Transparent,Color.Transparent,0); // dots so that the horizontal lines still be visible when changing from daily to mins etc...
				HLineDrawn = true;
				//CollectLines();
				
				if(!retrievemode)//save without rewriting the values
				{	
					CollectLines();
					HandelLines();
					WriteValue(false,targets); 
				} 
			}
			
			
		}
		
		private void CollectLines()
		{
			HLCollection.Clear();
						
			foreach (IDrawObject draw in DrawObjects)
			{  
				if (draw is ILine && draw.DrawType== ((ray? DrawType.Ray:DrawType.HorizontalLine)) && !draw.UserDrawn) // if the line is Horizontal
				{						
					ILine drawnLine = (ILine) draw; // get the Line proporties 
					HLCollection.Add(drawnLine.StartY);
				}
												
			}								
			
			HLCollection.Sort();
				
			if(Short)
			{
				if(targetLines == TargetLines.Three)
				{
				
					
					StopLineY =  HLCollection[4];
					EnterLineY = HLCollection[3];
					TargetLineY = HLCollection[2];
					TargetLineY2= HLCollection[1];
					TargetLineY3= HLCollection[0];
						
				}
				else
				{
					StopLineY =  HLCollection[0];
					EnterLineY = HLCollection[1];
					TargetLineY = HLCollection[2];
				}
				
			}
			else
			{
				StopLineY =  HLCollection[0];
				EnterLineY = HLCollection[1];
				TargetLineY = HLCollection[2];
				
				if(targetLines == TargetLines.Three)
				{
					TargetLineY2= HLCollection[3];
					TargetLineY3= HLCollection[4];
				}
				
			}
							
								
		}
		
		private void HandelLines()
		{
			if (HLineDrawn)
			{
						
				CollectLines();
				
				PotentialProfit=(Math.Abs(EnterLineY -TargetLineY)) * Instrument.MasterInstrument.PointValue;  
				PotentialProfit2=(Math.Abs(TargetLineY -TargetLineY2)) * Instrument.MasterInstrument.PointValue;  
				PotentialProfit3=(Math.Abs(TargetLineY2 -TargetLineY3)) * Instrument.MasterInstrument.PointValue;  
				PotentialLoss = (Math.Abs(EnterLineY - StopLineY)) * Instrument.MasterInstrument.PointValue;
								
				if(ray)
				{	
					EnterRLine.Pen.Color = Color.LightSlateGray;
					EnterRLine.Anchor1Y=EnterRLine.Anchor2Y=EnterLineY;
					EnterRLine.Pen.DashStyle =  DashStyle.Dash;
					TargetRLine.Anchor1Y =TargetRLine.Anchor2Y= TargetLineY;
					StopRLine.Anchor1Y =StopRLine.Anchor2Y= StopLineY;
					
					if(targetLines == TargetLines.Three)
					{	
						TargetRLine2.Anchor1BarsAgo=RayBarsAgo;
						TargetRLine3.Anchor1BarsAgo=RayBarsAgo;
						TargetRLine2.Anchor2BarsAgo=RayBarsAgo-1;
						TargetRLine3.Anchor2BarsAgo=RayBarsAgo-1;
					}
					//fix the ray 
					
					EnterRLine.Anchor1BarsAgo = RayBarsAgo;
					TargetRLine.Anchor1BarsAgo=RayBarsAgo;
					StopRLine.Anchor1BarsAgo =RayBarsAgo;
					EnterRLine.Anchor2BarsAgo= RayBarsAgo-1;
					TargetRLine.Anchor2BarsAgo=RayBarsAgo-1;
					StopRLine.Anchor2BarsAgo=RayBarsAgo-1;
					
					
				}
				else
				{
					EnterHLine.Pen.Color = Color.LightSlateGray;
					EnterHLine.Y=EnterLineY;
					EnterHLine.Pen.DashStyle =  DashStyle.Dash;
					TargetHLine.Y = TargetLineY;
					StopHLine.Y = StopLineY;
					
				}
				TargetDot.Y = (targetLines == TargetLines.One ? TargetLineY:TargetLineY3);// for scale issue when changing from daily to minute chart, horizontal line disappear
				StopDot.Y = StopLineY;
								
				RatioValue = ( (targetLines ==TargetLines.One) && Short ? (PotentialLoss/PotentialProfit):(PotentialProfit/PotentialLoss));
				
				if ((RatioValue) < 1.5 )
				{
					RatioTextColor=RedColor;
				}
				else if ((RatioValue) > 1.5 )
				{
					RatioTextColor=GreenColor;
				}
				else
				{
					RatioTextColor=Color.Black;
				}
				
				if(targetLines == TargetLines.Three)
				{	
					if(ray)
					{	
						TargetRLine2.Anchor1Y = TargetRLine2.Anchor2Y = TargetLineY2;
						TargetRLine3.Anchor1Y= TargetRLine3.Anchor2Y= TargetLineY3;
					}
					else
					{
						TargetHLine2.Y = TargetLineY2;
						TargetHLine3.Y = TargetLineY3;
					}				
					
					RatioValue2 = (TargetLineY2 - EnterLineY )/(EnterLineY  - StopLineY);
					RatioValue3 = (TargetLineY3 - EnterLineY )/(EnterLineY  - StopLineY);
										
					if ((RatioValue2) < 1.5 )
					{
						Ratio2TextColor=RedColor;
					}
					else if ((RatioValue2) > 1.5 )
					{
						Ratio2TextColor=GreenColor;
						Ratio3TextColor=GreenColor;
						
					}
					else
					{
						Ratio2TextColor=Color.Black;
					}
					if ((RatioValue3) < 1.5 )
					{
						Ratio3TextColor=RedColor;
					}
					else if ((RatioValue3) > 1.5 )
					{
						Ratio3TextColor=GreenColor;
						
					}
					else
					{
						Ratio3TextColor=Color.Black;
					}
				}
				
								
				if(Short)
				{
														
					if(targetLines == TargetLines.Three)
					{
						
						if(ray)
						{	
							TargetRLine.Pen.Color = GreenColor;
							StopRLine.Pen.Color = RedColor;
							TargetRLine2.Pen.Color = GreenColor;
							TargetRLine3.Pen.Color = GreenColor;
						}
						else
						{
							TargetHLine.Pen.Color = GreenColor;
							StopHLine.Pen.Color = RedColor;
							TargetHLine2.Pen.Color = GreenColor;
							TargetHLine3.Pen.Color = GreenColor;
						}
						EnterToTargetColor=GreenColor;
						UpSplitTagColor=GreenColor;
						EnterToStopColor=RedColor;
						LowerSplitTagColor=RedColor;
						StopLinetxtColor = RedColor;
						TargetLinetxtColor = GreenColor;
						contracts= (int)( ((accountSize * riskpercent)/100) /PotentialLoss);
					}
					else
					{
						
						if(ray)
						{	
							TargetRLine.Pen.Color = RedColor;
							StopRLine.Pen.Color = GreenColor;
						}
						else
						{
							TargetHLine.Pen.Color = RedColor;
							StopHLine.Pen.Color = GreenColor;
						}
						EnterToTargetColor=RedColor;
						UpSplitTagColor=RedColor;
						EnterToStopColor=GreenColor;
						LowerSplitTagColor=GreenColor;
						StopLinetxtColor = GreenColor;
						TargetLinetxtColor = RedColor;
						contracts= (int)( ((accountSize * riskpercent)/100) /PotentialProfit);
					}
					
						
				}
				else
				{
					if(ray)
					{
						TargetRLine.Pen.Color = GreenColor;
						StopRLine.Pen.Color = RedColor;
						if(targetLines == TargetLines.Three)
						{
							TargetRLine2.Pen.Color = GreenColor;
							TargetRLine3.Pen.Color = GreenColor;
						}
					}
					else
					{
						TargetHLine.Pen.Color = GreenColor;
						StopHLine.Pen.Color = RedColor;
						if(targetLines == TargetLines.Three)
						{
							TargetHLine2.Pen.Color = GreenColor;
							TargetHLine3.Pen.Color = GreenColor;
						}
					}
					
					
					EnterToTargetColor=GreenColor;
					UpSplitTagColor=GreenColor;
					EnterToStopColor=RedColor;
					LowerSplitTagColor=RedColor;
					StopLinetxtColor = RedColor;
					TargetLinetxtColor = GreenColor;
					contracts= (int)(((accountSize * riskpercent)/100) /PotentialLoss);
					
				}
				
				
			}
						
		}
		
			
		private void HandleInteractiveLines()
		{
			
			if (interactive == Interactive.Yes )
			{	
				
				PL = ( Short? EnterLineY-Close[0] : Close[0]-EnterLineY );
				if (!attached) // if not attached
				{
					if( PL < 0 )
					{
						InteractivePLColor= RedColor;
					}
					else if ( PL > 0 )
					{
						InteractivePLColor = GreenColor;
					}
					else
					{
						InteractivePLColor= Color.Black;
					}
					
				}
				else // if attached
				{
					PL=0;
					if(ray)
					{	
						EnterRLine.Anchor1Y=EnterRLine.Anchor2Y= Close[0];
						
					}
					else
					{
						EnterHLine.Y= Close[0];
					}
					RetrieveSavedLines();
					HandelLines();
				}
				InteractivePriceColor = PriceColor;
				
			}
		#endregion
			
		#region Retrieve Lines
		}
		
		private void RetrieveSavedLines()
		{
			
			if (GetValue(0,targets)!=-1 && GetValue(0,targets)!=0 && !RetrievalDone && !HLineDrawn && (GetValue(0,targets) == (targetLines == TargetLines.One? 3:5)))// if file exist and file is not  empty
			{
						
				for (int index = 2; index <GetValue(0,targets)+2; index++) 
				{
					
					CreateLines(GetValue(index,targets),true);// true to retrieve only without overwriting the file 
				}
				
				RetrievalDone = true;
				HLineDrawn = true;
				HandelLines();
			}
			
		}
		#endregion
		
		protected override void OnBarUpdate()
        {
            
			if (CurrentBar == Count-1 && btnDate5.Checked )
			{	
				
				RetrieveSavedLines();
					
				if (Close[0] != 0 && interactive == Interactive.Yes )
				{
					HandleInteractiveLines();
				}
				
				
			}
		}
		  
		
		public override void Dispose()
		{
			if (ChartControl != null)
			{
				this.ClearOutputWindow();
				this.ChartControl.ChartPanel.MouseUp -= MyMouseUpEvent;
				this.ChartControl.ChartPanel.MouseDown -= MyMouseDownEvent;
			}
			base.Dispose();
		}
		
		
       #region Properties
		[System.ComponentModel.RefreshProperties(RefreshProperties.All)] 
        [Description("Interactive price change indication")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("5.Interactive")]
        public Interactive Interactive
        {
            get { return interactive; }
            set {
					interactive = value;
					bool ContNewValue = (value == Interactive.Yes? false:true );
					
					PropertyDescriptor ContDescriptor = TypeDescriptor.GetProperties(this.GetType())["Contracts"];
					PropertyDescriptor AccountDescriptor = TypeDescriptor.GetProperties(this.GetType())["AccountSize"];
					PropertyDescriptor RiskDescriptor = TypeDescriptor.GetProperties(this.GetType())["Riskpercent"];
					
					ReadOnlyAttribute ContAttrib = (ReadOnlyAttribute)ContDescriptor.Attributes[typeof(ReadOnlyAttribute)];
					ReadOnlyAttribute AccountAttrib = (ReadOnlyAttribute)AccountDescriptor.Attributes[typeof(ReadOnlyAttribute)];
					ReadOnlyAttribute RiskAttrib = (ReadOnlyAttribute)RiskDescriptor.Attributes[typeof(ReadOnlyAttribute)];
					
					FieldInfo ContisReadOnly = ContAttrib.GetType().GetField("isReadOnly", BindingFlags.NonPublic | BindingFlags.Instance);
					FieldInfo AccountisReadOnly = AccountAttrib.GetType().GetField("isReadOnly", BindingFlags.NonPublic | BindingFlags.Instance);
					FieldInfo RiskisReadOnly = RiskAttrib.GetType().GetField("isReadOnly", BindingFlags.NonPublic | BindingFlags.Instance);
				
					ContisReadOnly.SetValue(ContAttrib, ContNewValue);
					AccountisReadOnly.SetValue(AccountAttrib, !ContNewValue);
					RiskisReadOnly.SetValue(RiskAttrib, !ContNewValue);
				}
        }
		[ReadOnly(false)]
		[Description("Account size in US$")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("1.Account Size $")]
        public double AccountSize
        {
            
			get { return 	accountSize;}
            set { accountSize =Math.Max(1,value);}
			
		}
		[ReadOnly(false)]
		[Description("The amount you want to risk in percent")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("2.Risk%")]
        public double Riskpercent
        {
            get { return 	riskpercent; }
            set { riskpercent =Math.Max(1,value); }
			
        }
		[ReadOnly(true)]
		[Description("If interactive mode is off, define how many contracts to trade (default 1), if interactive mode is on the quantity of number is based on Risk/Reward ")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("3.Contracts")]
        public int Contracts
        {
            get { return 	userscontracts; }
            set { userscontracts =Math.Max(1,value); }
			
        }
		[Description("Show the entries on startup?")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("6.Show On Startup")]
        public bool ShowOnStartup
        {
            get { return showOnStartup; }
            set { showOnStartup =value; }
		}
		[Description("How many target lines to use? ")]
        [Category(" Parameters")]
		[Gui.Design.DisplayNameAttribute("4.Traget Lines")]
        public TargetLines TargetLines
        {
            get { return targetLines; }
            set { targetLines =value; }
		}
		[Category(" Parameters")]
 		[Description("Use extended or short lines ")]
        [Gui.Design.DisplayName("7. Extended Lines")]
        public bool Ray
        {
            get { return !ray; }
            set { ray = !value; }
        }
		[Category(" Parameters")]
 		[Description("Lines Width in pixel")]
        [Gui.Design.DisplayName("8. Lines Width")]
        public int linesWidth
        {
            get { return LinesWidth; }
            set { LinesWidth = Math.Min(Math.Max(value,1),2); }
        }
		[Category(" Parameters")]
 		[Description("Target Line Color")]
        [Gui.Design.DisplayName("Target Lines Color")]
        public Color TagetLineColor
        {
            get { return GreenColor; }
            set { GreenColor = value; }
        }

        [Browsable(false)]
        public string TargetLineSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(GreenColor); }
            set { GreenColor = Gui.Design.SerializableColor.FromString(value); }
        }
		[Category(" Parameters")]
 		[Description("The Color of the pointer")]
        [Gui.Design.DisplayName("Beam Color")]
        public Color beamColor
        {
            get { return BeamColor; }
            set { BeamColor = value; }
        }

        [Browsable(false)]
        public string BeamColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(BeamColor); }
            set { BeamColor = Gui.Design.SerializableColor.FromString(value); }
        }
		[Category(" Parameters")]
 		[Description("Stop Line Color")]
        [Gui.Design.DisplayName("Stop Line Color")]
        public Color StopLineColor
        {
            get { return RedColor; }
            set { RedColor = value; }
        }
        [Browsable(false)]
        public string StopLineSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(RedColor); }
            set { RedColor = Gui.Design.SerializableColor.FromString(value); }
        }
		[Category(" Parameters")]
 		[Description("Price Tag Color")]
        [Gui.Design.DisplayName("Price Color")]
        public Color CurrentPriceColor
        {
            get { return PriceColor; }
            set { PriceColor = value; }
        }
        [Browsable(false)]
        public string PriceColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(PriceColor); }
            set { PriceColor = Gui.Design.SerializableColor.FromString(value); }
        }
		#endregion 
    }
}
public enum Interactive
		{
			Yes,
			No,
		}
public enum CalculationsBasedOn
		{
			User_Choice,
			Suggested_Contract_Qty,
		}
public enum TargetLines
		{
			One,
			Three,
		}
#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AdvancedRiskReward[] cacheAdvancedRiskReward = null;

        private static AdvancedRiskReward checkAdvancedRiskReward = new AdvancedRiskReward();

        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        public AdvancedRiskReward AdvancedRiskReward()
        {
            return AdvancedRiskReward(Input);
        }

        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        public AdvancedRiskReward AdvancedRiskReward(Data.IDataSeries input)
        {
            if (cacheAdvancedRiskReward != null)
                for (int idx = 0; idx < cacheAdvancedRiskReward.Length; idx++)
                    if (cacheAdvancedRiskReward[idx].EqualsInput(input))
                        return cacheAdvancedRiskReward[idx];

            lock (checkAdvancedRiskReward)
            {
                if (cacheAdvancedRiskReward != null)
                    for (int idx = 0; idx < cacheAdvancedRiskReward.Length; idx++)
                        if (cacheAdvancedRiskReward[idx].EqualsInput(input))
                            return cacheAdvancedRiskReward[idx];

                AdvancedRiskReward indicator = new AdvancedRiskReward();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedRiskReward[] tmp = new AdvancedRiskReward[cacheAdvancedRiskReward == null ? 1 : cacheAdvancedRiskReward.Length + 1];
                if (cacheAdvancedRiskReward != null)
                    cacheAdvancedRiskReward.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedRiskReward = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedRiskReward AdvancedRiskReward()
        {
            return _indicator.AdvancedRiskReward(Input);
        }

        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedRiskReward AdvancedRiskReward(Data.IDataSeries input)
        {
            return _indicator.AdvancedRiskReward(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedRiskReward AdvancedRiskReward()
        {
            return _indicator.AdvancedRiskReward(Input);
        }

        /// <summary>
        /// Advanced Risk Reward by Bassam Alshariti
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedRiskReward AdvancedRiskReward(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedRiskReward(input);
        }
    }
}
#endregion
